/**
 * @author Vladimir Kozhin <affka@affka.ru>
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _BaseObject2 = require('./BaseObject');

var _BaseObject3 = _interopRequireDefault(_BaseObject2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = function (_BaseObject) {
    _inherits(Component, _BaseObject);

    function Component() {
        _classCallCheck(this, Component);

        return _possibleConstructorReturn(this, (Component.__proto__ || Object.getPrototypeOf(Component)).apply(this, arguments));
    }

    _createClass(Component, [{
        key: 'preInit',
        value: function preInit() {
            this._events = {};

            _get(Component.prototype.__proto__ || Object.getPrototypeOf(Component.prototype), 'preInit', this).apply(this, arguments);
        }

        /**
         *
         * @param {string|string[]} names
         * @param {function} handler
         */

    }, {
        key: 'on',
        value: function on(names, handler) {
            if (!(names instanceof Array)) {
                names = [names];
            }

            for (var i = 0, l = names.length; i < l; i++) {
                var name = names[i];
                this._events[name] = this._events[name] || [];
                this._events[name].push(handler);
            }
        }

        /**
         *
         * @param {string|string[]} [names]
         * @param {function} [handler]
         */

    }, {
        key: 'off',
        value: function off(names, handler) {
            if (names) {
                if (!(names instanceof Array)) {
                    names = [names];
                }

                for (var i = 0, l = names.length; i < l; i++) {
                    var name = names[i];

                    if (this._events[name]) {
                        if (handler) {
                            var index = this._events[name].indexOf(handler);
                            if (index !== -1) {
                                this._events[name].splice(index, 1);
                            }
                        } else {
                            delete this._events[name];
                        }
                    }
                }
            } else {
                this._events = {};
            }
        }

        /**
         *
         * @param {string} name
         * @param {*[]} [args]
         */

    }, {
        key: 'trigger',
        value: function trigger(name, args) {
            args = args || [];

            if (this._events[name]) {
                for (var i = 0, l = this._events[name].length; i < l; i++) {
                    this._events[name][i].apply(null, args);
                }
            }
        }
    }]);

    return Component;
}(_BaseObject3.default);

exports.default = Component;