/**
 * @author Vladimir Kozhin <affka@affka.ru>
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Element2 = require('../base/Element');

var _Element3 = _interopRequireDefault(_Element2);

var _BrowserHelper = require('../helpers/BrowserHelper');

var _BrowserHelper2 = _interopRequireDefault(_BrowserHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputElement = function (_Element) {
    _inherits(InputElement, _Element);

    function InputElement() {
        _classCallCheck(this, InputElement);

        return _possibleConstructorReturn(this, (InputElement.__proto__ || Object.getPrototypeOf(InputElement)).apply(this, arguments));
    }

    _createClass(InputElement, [{
        key: 'preInit',
        value: function preInit() {

            /**
             * @type {string}
             */
            this.name = 'file';

            /**
             * @type {boolean}
             */
            this.multiple = false;

            /**
             * @type {function}
             */
            this.onChange = null;

            /**
             * @type {object}
             */
            this.inputAttributes = null;

            this._fileNames = {};

            _get(InputElement.prototype.__proto__ || Object.getPrototypeOf(InputElement.prototype), 'preInit', this).apply(this, arguments);
        }
    }, {
        key: 'init',
        value: function init() {
            var _this2 = this;

            this.element = document.createElement('input');
            this.element.type = 'file';
            this.element.name = this.name + (this.multiple ? '[]' : '');
            this.element.multiple = this.multiple;

            if (this.inputAttributes) {
                Object.keys(this.inputAttributes).forEach(function (key) {
                    _this2.element.setAttribute(key, _this2.inputAttributes[key]);
                });
            }

            // IE8 file field transparency fix.
            if (_BrowserHelper2.default.isIE()) {
                var style = this.element.style;
                style.visibility = 'hidden';
                setTimeout(function () {
                    return style.visibility = 'visible';
                }, 0);
            }

            // Subscribe on change input files
            if (this.onChange) {
                this.element.onchange = this.onChange;
            }

            this.hide();
        }

        /**
         *
         * @param {number} index
         * @returns {object}
         */

    }, {
        key: 'getFileNative',
        value: function getFileNative(index) {
            index = index || 0;
            return this.element.files && this.element.files[index] || null;
        }

        /**
         *
         * @param {number} index
         * @returns {string}
         */

    }, {
        key: 'getFilePath',
        value: function getFilePath(index) {
            index = index || 0;

            var file = this.getFileNative(index);
            if (!file) {
                return this.element.value || '';
            }

            return file.webkitRelativePath ? file.webkitRelativePath.replace(/^[\/\\]+/, '') : file.fileName || file.name || '';
        }

        /**
         *
         * @returns {number}
         */

    }, {
        key: 'getCount',
        value: function getCount() {
            if (this.element.files) {
                return this.element.files.length;
            }
            return this.element.value ? 1 : 0;
        }
    }, {
        key: 'freeze',
        value: function freeze() {
            this.element.onchange = null;
        }
    }, {
        key: 'destroy',
        value: function destroy() {
            this.element.onchange = null;
            _get(InputElement.prototype.__proto__ || Object.getPrototypeOf(InputElement.prototype), 'destroy', this).call(this);
        }
    }]);

    return InputElement;
}(_Element3.default);

exports.default = InputElement;