/**
 * @author Vladimir Kozhin <affka@affka.ru>
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _BaseObject2 = require('../base/BaseObject');

var _BaseObject3 = _interopRequireDefault(_BaseObject2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BrowserHelper = function (_BaseObject) {
    _inherits(BrowserHelper, _BaseObject);

    function BrowserHelper() {
        _classCallCheck(this, BrowserHelper);

        return _possibleConstructorReturn(this, (BrowserHelper.__proto__ || Object.getPrototypeOf(BrowserHelper)).apply(this, arguments));
    }

    _createClass(BrowserHelper, null, [{
        key: '_detect',
        value: function _detect() {
            if (this._browserName !== null) {
                return;
            }

            var ua = navigator.userAgent,
                tem,
                M = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
            if (/trident/i.test(M[1])) {
                tem = /\brv[ :]+(\d+)/g.exec(ua) || [];

                this._browserName = 'trident';
                this._browserVersion = tem[1] || 1;
                return;
            }
            if (M[1] === 'Chrome') {
                tem = ua.match(/\b(OPR|Edge)\/(\d+)/);
                if (tem != null) {
                    this._browserName = tem[1].replace('OPR', 'Opera').toLowerCase();
                    this._browserVersion = tem[2] || 1;
                    return;
                }
            }
            M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];
            if ((tem = ua.match(/version\/(\d+)/i)) != null) {
                M.splice(1, 1, tem[1]);
            }

            this._browserName = M[0].toLowerCase();
            this._browserVersion = M[1] || 1;
        }
    }, {
        key: 'isIE',
        value: function isIE() {
            this._detect();
            return this._browserName === 'msie' ? this._browserVersion : false;
        }
    }, {
        key: 'isWebkit',
        value: function isWebkit() {
            return this.isChrome() || this.isSafari();
        }
    }, {
        key: 'isChrome',
        value: function isChrome() {
            this._detect();
            return this._browserName === 'chrome' ? this._browserVersion : false;
        }
    }, {
        key: 'isSafari',
        value: function isSafari() {
            this._detect();
            return this._browserName === 'safari' ? this._browserVersion : false;
        }
    }, {
        key: 'isFirefox',
        value: function isFirefox() {
            this._detect();
            return this._browserName === 'firefox' ? this._browserVersion : false;
        }
    }, {
        key: 'isTrident',
        value: function isTrident() {
            this._detect();
            return this._browserName === 'trident' ? this._browserVersion : false;
        }
    }, {
        key: 'isFileDropSupport',
        value: function isFileDropSupport() {
            return 'draggable' in document.createElement('span') && typeof window.FileReader !== 'undefined';
        }
    }]);

    return BrowserHelper;
}(_BaseObject3.default);

BrowserHelper._browserName = null;
BrowserHelper._browserVersion = null;
exports.default = BrowserHelper;