/**
 * @author Vladimir Kozhin <affka@affka.ru>
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Manager2 = require('../base/Manager');

var _Manager3 = _interopRequireDefault(_Manager2);

var _QueueCollection = require('../models/QueueCollection');

var _QueueCollection2 = _interopRequireDefault(_QueueCollection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var QueueManager = function (_Manager) {
    _inherits(QueueManager, _Manager);

    function QueueManager() {
        _classCallCheck(this, QueueManager);

        return _possibleConstructorReturn(this, (QueueManager.__proto__ || Object.getPrototypeOf(QueueManager)).apply(this, arguments));
    }

    _createClass(QueueManager, [{
        key: 'preInit',
        value: function preInit() {
            this.autoStart = true;

            _get(QueueManager.prototype.__proto__ || Object.getPrototypeOf(QueueManager.prototype), 'preInit', this).apply(this, arguments);
        }
    }, {
        key: 'init',
        value: function init() {
            _get(QueueManager.prototype.__proto__ || Object.getPrototypeOf(QueueManager.prototype), 'init', this).call(this);

            if (this.autoStart) {
                this.collection.on(_QueueCollection2.default.EVENT_ADD, this._queueNext.bind(this));
            }
            this.collection.on(_QueueCollection2.default.EVENT_ITEM_END, this._queueNext.bind(this));
        }
    }, {
        key: 'start',
        value: function start() {
            this._queueNext();
        }
    }, {
        key: '_queueNext',
        value: function _queueNext() {
            var file = this.collection.getNextForUpload();
            if (file) {
                file.start();
                this._queueNext();
            }
        }
    }]);

    return QueueManager;
}(_Manager3.default);

exports.default = QueueManager;