/**
* @author Vladimir Kozhin <affka@affka.ru>
* @license MIT
*/

'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Component2 = require('../base/Component');

var _Component3 = _interopRequireDefault(_Component2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseUploader = function (_Component) {
    _inherits(BaseUploader, _Component);

    function BaseUploader() {
        _classCallCheck(this, BaseUploader);

        return _possibleConstructorReturn(this, (BaseUploader.__proto__ || Object.getPrototypeOf(BaseUploader)).apply(this, arguments));
    }

    _createClass(BaseUploader, [{
        key: 'preInit',
        value: function preInit() {

            /**
             * @type {function}
             */
            this.responseParser = null;

            /**
             * @type {string}
             */
            this._url = '';

            /**
             * @type {object}
             */
            this._params = {};

            _get(BaseUploader.prototype.__proto__ || Object.getPrototypeOf(BaseUploader.prototype), 'preInit', this).apply(this, arguments);
        }
    }, {
        key: 'start',
        value: function start() {}
    }, {
        key: 'stop',
        value: function stop() {}

        /**
         *
         * @param {string} value
         */

    }, {
        key: 'setUrl',
        value: function setUrl(value) {
            this._url = value;
        }

        /**
         *
         * @returns {string}
         */

    }, {
        key: 'getUrl',
        value: function getUrl() {
            return this._url;
        }

        /**
         *
         * @param {object} value
         */

    }, {
        key: 'setParams',
        value: function setParams(value) {
            this._params = value;
        }

        /**
         *
         * @returns {string}
         */

    }, {
        key: 'getParams',
        value: function getParams() {
            return this._params;
        }

        /**
         *
         * @param {string} text
         * @returns {[]}
         * @protected
         */

    }, {
        key: '_defaultResponseParser',
        value: function _defaultResponseParser(text) {
            var data = null;
            try {
                data = JSON.parse(text);
            } catch (e) {}
            return data;
        }
    }], [{
        key: 'isProgressSupport',
        value: function isProgressSupport() {
            return false;
        }
    }, {
        key: 'addUrlParams',
        value: function addUrlParams(url, params) {
            return url + (url.indexOf('?') === -1 ? '?' : '&') + this._serialize(params).join('&');
        }
    }, {
        key: '_serialize',
        value: function _serialize(params, parentKey) {
            parentKey = parentKey || '';

            var serialized = [];
            for (var key in params) {
                if (params.hasOwnProperty(key)) {
                    var encodedKey = encodeURIComponent(parentKey ? parentKey + '[' + key + ']' : key);

                    if (params[key] instanceof Array) {
                        for (var i = 0, l = params[key].length; i < l; i++) {
                            serialized.push(encodedKey + '[]=' + encodeURIComponent(params[key][i]));
                        }
                    } else if (_typeof(params[key]) === 'object') {
                        serialized = serialized.concat(this._serialize(params[key], key));
                    } else if (typeof params[key] === 'boolean') {
                        serialized.push(encodedKey + '=' + (params[key] ? 1 : 0));
                    } else {
                        serialized.push(encodedKey + '=' + encodeURIComponent(params[key]));
                    }
                }
            }
            return serialized;
        }
    }]);

    return BaseUploader;
}(_Component3.default);

exports.default = BaseUploader;


BaseUploader.EVENT_START = 'start';
BaseUploader.EVENT_PROGRESS = 'progress';
BaseUploader.EVENT_ERROR = 'error';
BaseUploader.EVENT_END_PART = 'end_part';
BaseUploader.EVENT_END = 'end';